This change creates a proper vserver stub that includes all new files
[vserver-reference.git] / build.sh
index 81b5dd8..add5e90 100755 (executable)
--- a/build.sh
+++ b/build.sh
@@ -1,11 +1,18 @@
 #!/bin/bash
 #
-# Builds VServer reference image
+# Builds all reference image for vservers.  To optimize for space it
+# will only build a complete base vserver reference image and then
+# builds "stub" images that are just contain the additional files
+# and/or changes for a given reference image.  This is done to shrink
+# the RPM itself.  These will be pieced back together with the base
+# vserver reference image by an init script that is installed on the
+# node.
 #
 # Mark Huang <mlhuang@cs.princeton.edu>
-# Copyright (C) 2004-2006 The Trustees of Princeton University
+# Marc E. Fiuczynski <mef@cs.princeton.edu>
+# Copyright (C) 2004-2007 The Trustees of Princeton University
 #
-# $Id$
+# $Id: build.sh,v 1.20 2007/09/06 20:41:23 faiyaza Exp $
 #
 
 PATH=/sbin:/bin:/usr/sbin:/usr/bin
@@ -23,102 +30,83 @@ fi
 
 export PATH
 
-# Release and architecture to install
-releasever=2
-basearch=i386
-
-# Packages to install
-packagelist=(
-bash
-coreutils
-iputils
-kernel-vserver
-bzip2
-crontabs
-diffutils
-logrotate
-openssh-clients
-passwd
-rsh
-rsync
-sudo
-tcpdump
-telnet
-traceroute
-time
-vixie-cron
-wget
-yum
-curl
-gzip
-perl
-python
-tar
-)
-
-usage()
-{
-    echo "Usage: build.sh [OPTION]..."
-    echo "     -r release      Fedora release number (default: $releasever)"
-    echo "     -a arch         Fedora architecture (default: $basearch)"
-    echo "     -h              This message"
-    exit 1
-}
-
-# Get options
-while getopts "r:a:h" opt ; do
-    case $opt in
-       r)
-           releasever=$OPTARG
-           ;;
-       a)
-           basearch=$OPTARG
-           ;;
-       h|*)
-           usage
-           ;;
-    esac
-done
+# build.common comes from the build module
+. build.common
+
+pl_process_fedora_options $@
+shiftcount=$?
+shift $shiftcount
 
 # Do not tolerate errors
 set -e
 
-# Make /vservers
-vroot=$PWD/vservers/vserver-reference
-install -d -m 755 $vroot
+# Path's to the vserver references images and stubs
+vrefdir=$PWD/vservers/.vref
+vstubdir=$PWD/vservers/.vstub
+
+# XXX: The vserver reference name should be passed in as an argument
+# rather than being hardcoded.
+vrefname=default
+
+# Make /vservers and default vserver reference image
+vref=${vrefdir}/${vrefname}
+install -d -m 755 ${vref}
+
+# "Parse" out the packages and groups for mkfedora
+vrefpackages=$(grep "^package:.*" vserver-reference.lst | awk '{print $2}')
+vrefgroups=$(grep "^group:.*" vserver-reference.lst | awk '{print $2}')
+options=""
+for package in ${vrefpackages} ; do  options="$options -p $package"; done
+for group in ${vrefgroups} ; do options="$options -g $group"; done
+
+# Populate a minimal /dev in the reference image
+pl_makedevs ${vref}
+
+# Populate image with vserver-reference packages
+pl_setup_chroot ${vref} ${options}
+
+for systemvserver in reference-vservers/*.lst ; do
+    NAME=$(basename $systemvserver .lst)
+
+    # "Parse" out the packages and groups for yum
+    systempackages=$(grep "^package:.*" $systemvserver | awk '{print $2}')
+    systemgroups=$(grep "^group:.*" $systemvserver | awk '{print $2}')
+
+    vdir=${vstubdir}/${NAME}
+    rm -rf ${vdir}/*
+    install -d -m 755 ${vdir}
+
+    # Clone the base vserver reference to the system vserver reference
+
+       # OPTIMIZATION: Consider using "cp -al" in the future
+    (cd ${vref} && find . | cpio -m -d -u -p ${vdir})
+    rm -f ${vdir}/var/lib/rpm/__db*
+
+    # Communicate to the initialization script from which vref this stub was cloned
+    echo ${vrefname} > ${vdir}.cloned
+
+    # Install the system vserver specific packages
+    [ -n "$systempackages" ] && yum -c ${vdir}/etc/yum.conf --installroot=${vdir} -y install $systempackages
+    [ -n "$systemgroups" ] && yum -c ${vdir}/etc/yum.conf --installroot=${vdir} -y groupinstall $systemgroups
+
+    # Create a copy of the system vserver w/o the vserver reference files. This is a two step process:
+
+    # step 1: figure out the new/changed files in ${vdir} vs. ${vref} and compute ${vdir}.changes
+    rsync -anv ${vdir}/ ${vref}/ > ${vdir}.changes
+    linecount=$(wc -l ${vdir}.changes | awk ' { print $1 } ')
+    let headcount=$linecount-3
+    let tailcount=$headcount-1
+    head -${headcount} ${vdir}.changes > ${vdir}.changes.1
+    tail -${tailcount} ${vdir}.changes.1 > ${vdir}.changes
+    rm -f ${vdir}.changes.1
 
-# Install vserver-reference system
-for package in "${packagelist[@]}" ; do
-    packages="$packages -p $package"
+    # step 2: create the ${vdir} with just the list given in ${vdir}.changes 
+    install -d -m 755 ${vdir}-tmp/
+    rm -rf ${vdir}-tmp/*
+    (cd ${vdir} && cpio -l -m -d -u -p ${vdir}-tmp < ${vdir}.changes)
+    rm -rf ${vdir}
+    rm -f  ${vdir}.changes
+    mv ${vdir}-tmp ${vdir}
 done
-mkfedora -v -r $releasever -a $basearch $packages $vroot
-
-# Clean /dev
-rm -rf $vroot/dev
-mkdir -p $vroot/dev
-mknod -m 666 $vroot/dev/null c 1 3
-mknod -m 666 $vroot/dev/zero c 1 5
-mknod -m 666 $vroot/dev/full c 1 7
-mknod -m 644 $vroot/dev/random c 1 8
-mknod -m 644 $vroot/dev/urandom c 1 9
-mknod -m 666 $vroot/dev/tty c 5 0
-mknod -m 666 $vroot/dev/ptmx c 5 2
-# For bash command substitution
-ln -nsf ../proc/self/fd /dev/fd
-# For df and linuxconf
-touch $vroot/dev/hdv1
-# For TUN/TAP
-mkdir -p $vroot/dev/net
-mknod -m 600 $vroot/dev/net/tun c 10 200
-# For pseudo ttys
-mkdir -p $vroot/dev/pts
-
-# Disable all services in reference image
-chroot $vroot sh -c "/sbin/chkconfig --list | awk '{ print \$1 }' | xargs -i /sbin/chkconfig {} off"
-
-# This tells the Boot Manager that it is okay to update
-# /etc/resolv.conf and /etc/hosts whenever the network configuration
-# changes. Users are free to delete this file.
-touch $vroot/etc/AUTO_UPDATE_NET_FILES
 
 exit 0